#include <windows.h>
#include <commctrl.h>
#include <string.h>
#include "cpl.h"
#include "resource.h"

HINSTANCE hInst = NULL;

BOOL CALLBACK PanelFunc(HWND, UINT, WPARAM, LPARAM);

BOOL WINAPI CALLBACK __declspec(dllexport) CPlApplet(HWND hwndCPL, UINT uMsg, LPARAM lParam1, LPARAM lParam2)
{
	LPCPLINFO lpCPlInfo;
	switch (uMsg) {
	case CPL_INIT:      // first message, sent once
		hInst = GetModuleHandle("cpanel.cpl");
		return TRUE;

	case CPL_GETCOUNT:  // second message, sent once
		return 1; //one applet only

	case CPL_INQUIRE: // third message, sent once per application
		lpCPlInfo = (LPCPLINFO) lParam2;
		lpCPlInfo->lData = 0;
		lpCPlInfo->idIcon = PANEL_ICON;
		lpCPlInfo->idName = PANEL_NAME;
		lpCPlInfo->idInfo = PANEL_DESC;
		break;

	case CPL_DBLCLK:    // application started
		DialogBox(hInst, MAKEINTRESOURCE(PANEL_DLG), hwndCPL, PanelFunc);
		break;

	case CPL_STOP:      // sent once per application before CPL_EXIT
		break;

	case CPL_EXIT:    // sent once before FreeLibrary is called
		break;

	default:

		break;
	}
	return 0;
}

BOOL WINAPI CALLBACK __declspec(dllexport) PanelFunc(HWND hdwnd, UINT message,WPARAM wParam, LPARAM lParam)
{
	switch(message){
	case WM_NOTIFY:
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case IDD_ONE:
			return 1;
		case IDD_TWO:
			return 1;
		case IDOK:
		case WM_CLOSE:
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		}
		break;

	case WM_INITDIALOG:
		char str[80];
		strcpy(str,"BEEP!");
		MessageBeep(16);
		SetDlgItemText(hdwnd,IDC_OUTPUT, str);
		return 1;
	}

	return 0;
}

